﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;

namespace WpfApplication1.Data
{
    public class VM
    {
        public VM()
        {
            Units = new ObservableCollection<ParameterUnit>();
            Units.Add(new ParameterUnit()
            {
                UnitId = "x0",
                Name = "meter",
                UnitSymbol = "m"
            });
            Units.Add(new ParameterUnit()
            {
                UnitId = "x1",
                Name = "degree",
                UnitSymbol = "°"
            });
            Units.Add(new ParameterUnit()
            {
                UnitId = "x2",
                Name = "gram",
                UnitSymbol = "g"
            });

            Parameters = new ObservableCollection<ParameterUi>();

            for (int i = 1; i <= 5000; i++)
            {
                var paraParent = new ParameterUi();
                Random rnd = new Random();
                bool isActive = true;
                ParameterUnit unit = null;
                #region random
                
                //var valRnd = rnd.Next(0, 4);
                //switch (valRnd)
                //{
                //    case 1:
                //        unit = new ParameterUnit()
                //        {
                //            UnitId = "0",
                //            //Id = 0,
                //            Name = "meter",
                //            UnitSymbol = "m"
                //        };
                //        break;
                //    case 2:
                //        unit = new ParameterUnit()
                //        {
                //            UnitId = "1",
                //            //Id = 1,
                //            Name = "degree",
                //            UnitSymbol = "°"
                //        };
                //        break;
                //    case 3:
                //        unit = new ParameterUnit()
                //        {
                //            UnitId = "2",
                //            //Id = 2,
                //            Name = "gram",
                //            UnitSymbol = "g"
                //        };
                //        break;
                //    case 4:
                //        unit = new ParameterUnit()
                //        {
                //            UnitId = "dummy",
                //            //Id = -1,
                //            Name = "",
                //            UnitSymbol = ""
                //        };
                //        break;
                //}
                #endregion
                unit = new ParameterUnit()
                {
                    UnitId = "x2",
                    Name = "gram",
                    UnitSymbol = "g"
                };

                paraParent.Self = new ParameterUiItem()
                {
                    Id = i,
                    Name = "Parameter " + i,
                    Unit = unit,
                    IsActive = isActive

                };
                // create childs
                for (int j = 0; j < rnd.Next(0, 10); j++)
                {
                    var paraChild = new ParameterUiItem();
                    paraChild.Id = rnd.Next(5000, 250000);
                    paraChild.Name = "Parameter " + paraChild.Id;
                    paraChild.Unit = Units.First(x => x.UnitId == paraParent.Self.Unit.UnitId);
                    paraChild.IsActive = isActive;
                    paraParent.Childs.Add(paraChild);
                }
                Parameters.Add(paraParent);
            }
        }

        public ICommand DeleteParentParameter { get; private set; }

        public bool IsBusy { get; set; }

        public ObservableCollection<ParameterUi> Parameters { get; set; }

        public ObservableCollection<ParameterUnit> Units { get; set; }
    }
}
